// -*- C++ -*-
// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================
#ifndef AIDA_IPLOTTERSTYLE_H
#define AIDA_IPLOTTERSTYLE_H 1

//  This file is part of the AIDA library
//  Copyright (C) 2002 by the AIDA team.  All rights reserved.
//  This library is free software and under the terms of the
//  GNU Library General Public License described in the LGPL.txt 

#include "AIDA/IBaseStyle.h"

namespace AIDA {

class IAxisStyle;
class IDataStyle;
class IInfoStyle;
class ITitleStyle;

/**
 * User level interface to plotter style.
 * A plotter style permit to customize various part
 * of the plotting "scene" (axes, titles, data 
 * representations, etc...)
 *
 * @author The AIDA team (http://aida.freehep.org/)
 *
 */

class IPlotterStyle : virtual public IBaseStyle {

public: 
    /// Destructor.
    virtual ~IPlotterStyle() { /* nop */; }

  /** 
   * Get style of various plotting scene parts.
   */
    virtual IDataStyle & dataStyle() = 0;

    virtual IAxisStyle & xAxisStyle() = 0;

    virtual IAxisStyle & yAxisStyle() = 0;

    virtual IAxisStyle & zAxisStyle() = 0;

    virtual ITitleStyle & titleStyle() = 0;

    virtual IInfoStyle & infoStyle() = 0;

  /** 
   * Set style of various plotting scene parts.
   */
    virtual bool setDataStyle(const IDataStyle & dataStyle) = 0;

    virtual bool setAxisStyleX(const IAxisStyle & xAxisStyle) = 0;

    virtual bool setAxisStyleY(const IAxisStyle & yAxisStyle) = 0;

    virtual bool setAxisStyleZ(const IAxisStyle & zAxisStyle) = 0;

    virtual bool setTitleStyle(const ITitleStyle & textStyle) = 0;

    virtual bool setInfoStyle(const IInfoStyle & infoStyle) = 0;
}; // class
} // namespace AIDA
#endif /* ifndef AIDA_IPLOTTERSTYLE_H */
